/// <reference types="node" />
import { IReversibleJsonPatch, Type } from "./common";
import { Schema } from "./schema";
export declare class PatchPack {
    schema: Schema;
    constructor(types?: {
        [type: string]: string[] | Type<any>;
    });
    encodeState(value: any, includeTypes?: boolean, updateSchema?: boolean): Buffer;
    decodeState<T = any>(buffer: Buffer): any;
    private encodeNode;
    private decodeNode;
    encodePatch(patch: IReversibleJsonPatch, updateSchema?: boolean): Buffer;
    decodePatch(buffer: Buffer): IReversibleJsonPatch;
    encode(value: any): Buffer;
    decode(buffer: Buffer): any;
}
