import { ISchemaType, ISchemaNode, NodeType, TSchemaType, Type } from "./common";
export declare class Schema {
    private _types;
    private _nodes;
    private _nextId;
    constructor(types: {
        [type: string]: string[] | Type<any>;
    });
    get types(): TSchemaType[];
    addType(name: string, props: string[], ref?: Type<any>): void;
    typeByName(name: string): ISchemaType | undefined;
    get root(): ISchemaNode;
    get nextId(): number;
    init(types: TSchemaType[]): void;
    getNode(nodeId: number): ISchemaNode | undefined;
    getNodePath(sn?: ISchemaNode, key?: string | number): string;
    getChildNode(sn: ISchemaNode, name: string | number): ISchemaNode | undefined;
    findType(value: any): ISchemaType | undefined;
    getType(index: number): NodeType;
    getChildIndex(parent: ISchemaNode, key: string | number): number;
    getChildName(parent: ISchemaNode | undefined, index: number): string | number;
    createNode(id: number, parent: ISchemaNode | undefined, type: NodeType, key: string | number, index: number): ISchemaNode;
    deleteNode(node: ISchemaNode): void;
}
